/* ■■■■■■■■■■■■■ ARMOSY-2 Example ■■■■■■■■■■■■

Control IN, OUT, Relay, Beep, Bottons, LEDs => UTFT   

Hardware: ARMOSY-2
Version HW: 2.21
Create: 22.04.2016

   ■■■■■■■■■■■■■ TERMINAL CONNECTION ■■■■■■■■■■■■
63 - IN POWER, VCC min 8V/1A!
64 - IN POWER, -"-

   ■■■■■■■■■■■■■ JUMPER ■■■■■■■■■■■■
Factory Default

*/

// ■ LIBRARY
#include <UTFT.h>   //Driver UTFT


// ■ DECLARATIONS
UTFT  myGLCD(ITDB24,38,39,40,41); // RS, WR, CS, REST
extern uint8_t BigFont[]; // UTFT Fonds
extern uint8_t SmallFont[]; // UTFT Fonds

#define IN_1  54  // Terminal 1,2
#define IN_2  55  // Terminal 3,4
#define IN_3  56  // Terminal 5,6
#define IN_4  57  // terminal 7,8
#define IN_5  58  // Terminal 9,10
#define IN_6  59  // Terminal 11,12
#define IN_7  60  // Terminal 13,14
#define IN_8  61  // Terminal 15, 16
#define ACS712_1 62  // ACS712 I1 Terminal 17,18
#define ACS712_2 63  // ACS712 I2 Terminal 19,20
#define A10  64  // System Voltage 3.3V
#define A11  65  // System Voltage 5V
#define LED_GREEN 12 // LED GREEN 
#define LED_RED 68  // LED RED 
#define BUTT_H  47  // Buttons High
#define BUTT_L  48  // Buttons Low

byte RELE_1 = 30;  //Relay 1, terminal 21,22,23
byte RELE_2 = 31;  //Relay 2, terminal 24,25,26
byte RELE_3 = 32;  //Relay 3, terminal 27,28,29
byte RELE_4 = 33;  //Relay 4, terminal 30,31,32
byte OUT_1 = 6; // Terminal 33,34, PWM
byte OUT_2 = 7; // Terminal 35,36, PWM
byte OUT_3 = 8; // Terminal 37,38, PWM
byte OUT_4 = 9; // Terminal 39,40, PWM
byte OUT_5 = 34; //Terminal 41,42 
byte OUT_6 = 35; //Terminal 43,44
byte OUT_7 = 36; //Terminal 45,46
byte OUT_8 = 37; //Terminal 47,48
byte BEEP = 13; // Beep Tone
bool b_BUTT_H = 1; // State Button H    
bool b_BUTT_L = 1; // State Button L


#define U_1  49  // Terminal 49
#define U_2  50  // Terminal 50
#define U_3  51  // Terminal 51
#define U_4  52  // Terminal 52
#define U_5  66  // Terminal 53
#define U_6  69  // Terminal 54
#define U_7  11  // Terminal 55
#define U_8  2  // Terminal 56


// ■■■■■■■■■■■■■ SETUP ■■■■■■■■■■■■

void setup()
{

// ■ UTFT
  myGLCD.InitLCD();               // Initialization LCD              
  myGLCD.clrScr();                // Clear Screen
  myGLCD.fillScr(VGA_WHITE);      // VGA Background Transparency
  myGLCD.setColor(0, 0, 0);       // Black Fonds
  myGLCD.setBackColor(255, 255, 255); // White Background
  myGLCD.setFont(BigFont);        // Select Font 

// ■ INPUT
   pinMode(IN_1, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_2, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_3, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_4, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_5, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_6, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_7, INPUT_PULLUP);   // ON pull-up
   pinMode(IN_8, INPUT_PULLUP);   // ON pull-up
   pinMode(BUTT_H, INPUT_PULLUP);  // ON pull-up
   pinMode(BUTT_L, INPUT_PULLUP);  // ON pull-up
 
 // ■ OUTPUT 
  pinMode(LED_RED, OUTPUT); 
  pinMode(LED_GREEN, OUTPUT); 
  pinMode(RELE_1, OUTPUT); 
  pinMode(RELE_2, OUTPUT); 
  pinMode(RELE_3, OUTPUT); 
  pinMode(RELE_4, OUTPUT); 
  pinMode(OUT_1, OUTPUT); 
  pinMode(OUT_2, OUTPUT); 
  pinMode(OUT_3, OUTPUT); 
  pinMode(OUT_4, OUTPUT); 
  pinMode(OUT_5, OUTPUT); 
  pinMode(OUT_6, OUTPUT); 
  pinMode(OUT_7, OUTPUT); 
  pinMode(OUT_8, OUTPUT); 
  pinMode(BEEP, OUTPUT); 
  digitalWrite(LED_GREEN, HIGH);
  digitalWrite(LED_RED, HIGH);
  digitalWrite(RELE_1, LOW);
  digitalWrite(RELE_2, LOW);
  digitalWrite(RELE_3, LOW);
  digitalWrite(RELE_4, LOW);
  digitalWrite(OUT_1, HIGH); 
  digitalWrite(OUT_2, HIGH);
  digitalWrite(OUT_3, HIGH);
  digitalWrite(OUT_4, HIGH);
  digitalWrite(OUT_5, HIGH);
  digitalWrite(OUT_6, HIGH);
  digitalWrite(OUT_7, HIGH);
  digitalWrite(OUT_8, HIGH);
  digitalWrite(BEEP, HIGH);

  // ■ HEADER  
  myGLCD.print("ARMOSY2 - SW0009", CENTER, 10);             
  myGLCD.print("www.hwpro.cz", CENTER, 220); 
  myGLCD.setFont(SmallFont);        // Select Font 
  myGLCD.print("Loop input terminal - IN", 5, 175);
  myGLCD.print("Press Buttons - change OUT", 5, 70);

}


// ■■■■■■■■■■■■■ MAIN ■■■■■■■■■■■■

void loop()
{
  Print_Events (); // Print Events UTFT
  Read_Buttons (); // Read Events Buttons
}


// Print Events
void Print_Events(){
    myGLCD.setFont(SmallFont);
    myGLCD.setColor(0, 0, 0);   // BLACK
    myGLCD.setBackColor(255, 255, 255); // RGB
 
  // Read bit buttons H
    myGLCD.setColor(0, 0, 0);             // cerny fond
    myGLCD.print("Buttons:", 5, 105); 
    myGLCD.print("H", 75, 105); 
    myGLCD.setColor(0,0,0);   // cerny obrys okolo indikatoru
    int x=90;int y=110; int r=7;
    myGLCD.drawCircle(x, y, r);
    
    if   (b_BUTT_H == 0){ 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(90,110,6); // od leva, od vrsku, prumer
      digitalWrite(OUT_1, LOW); 
      digitalWrite(OUT_2, LOW);
      digitalWrite(OUT_3, LOW);
      digitalWrite(OUT_4, LOW);
      digitalWrite(OUT_5, LOW);
      digitalWrite(OUT_6, LOW);
      digitalWrite(OUT_7, LOW);
      digitalWrite(OUT_8, LOW);
      digitalWrite(LED_GREEN, LOW); 
   }
    else { 
      myGLCD.setColor(255,255,255);   
      myGLCD.fillCircle(90,110,6); 
      digitalWrite(OUT_1, HIGH); 
      digitalWrite(OUT_2, HIGH);
      digitalWrite(OUT_3, HIGH);
      digitalWrite(OUT_4, HIGH);
      digitalWrite(OUT_5, HIGH);
      digitalWrite(OUT_6, HIGH);
      digitalWrite(OUT_7, HIGH);
      digitalWrite(OUT_8, HIGH);
      digitalWrite(LED_GREEN, HIGH);   
  }
 
  // Read bit buttons L
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("L", 105, 105); 
    myGLCD.setColor(0,0,0);  
    int x2=120; int y2=110; int r2=7;
    myGLCD.drawCircle(x2, y2, r2);
    
    if   (b_BUTT_L == 0){ 
      myGLCD.setColor(255,0,0);    
      myGLCD.fillCircle(120,110,6); 
      digitalWrite(RELE_1, HIGH);
      digitalWrite(RELE_2, HIGH);
      digitalWrite(RELE_3, HIGH);
      digitalWrite(RELE_4, HIGH);
      digitalWrite(LED_RED, LOW); 
    }
    else { 
      myGLCD.setColor(255,255,255);     
      myGLCD.fillCircle(120,110,6); 
      digitalWrite(RELE_1, LOW);
      digitalWrite(RELE_2, LOW);
      digitalWrite(RELE_3, LOW);
      digitalWrite(RELE_4, LOW);
      digitalWrite(LED_RED, HIGH);
    }

// Rele 1
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("Relay:", 150, 105); 
    myGLCD.print("1", 195, 105); 
    myGLCD.setColor(0,0,0);   
    int x19=210; int y19=110; int r19=7;
    myGLCD.drawCircle(x19, y19, r19);
    
    if (digitalRead(RELE_1) == 1) { 
      myGLCD.setColor(0,255,0);    
      myGLCD.fillCircle(210,110,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(210,110,6); 
    }
    
    
// Relay 2
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("2", 225, 105); 
    myGLCD.setColor(0,0,0);   
    int x20=240; int y20=110; int r20=7;
    myGLCD.drawCircle(x20, y20, r20);
    
    if (digitalRead(RELE_2) == HIGH) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(240,110,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(240,110,6);  
    }

// Relay 3
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("3", 255, 105); 
    myGLCD.setColor(0,0,0);  
    int x21=270; int y21=110; int r21=7;
    myGLCD.drawCircle(x21, y21, r21);
    
    if (digitalRead(RELE_3) == HIGH) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(270,110,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(270,110,6); 
    }
   

// Relay 4
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("4", 285, 105); 
    myGLCD.setColor(0,0,0);   
    int x22=300; int y22=110; int r22=7;
    myGLCD.drawCircle(x22, y22, r22);
    
    if (digitalRead(RELE_4) == HIGH) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(300,110,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(300,110,6);  
    }
   
  // Input 1
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("Input:", 5, 145); 
    myGLCD.print("1", 75, 145); 
    myGLCD.setColor(0,0,0);   
    int x3=90; int y3=150; int r3=7;
    myGLCD.drawCircle(x3, y3, r3);
    
    if (digitalRead(IN_1) == false) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(90,150,6);  
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(90,150,6);  
    }
     
  // Input 2
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("2", 105, 145); 
    myGLCD.setColor(0,0,0);   
    int x4=120; int y4=150; int r4=7;
    myGLCD.drawCircle(x4, y4, r4);
    
    if (digitalRead(IN_2) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(120,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255);
      myGLCD.fillCircle(120,150,6); 
    }

  // Input 3
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("3", 135, 145); 
    myGLCD.setColor(0,0,0);   
    int x5=150; int y5=150; int r5=7;
    myGLCD.drawCircle(x5, y5, r5);
    
    if (digitalRead(IN_3) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(150,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(150,150,6);  
    }

// Input 4
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("4", 165, 145); 
    myGLCD.setColor(0,0,0);   
    int x6=180; int y6=150; int r6=7;
    myGLCD.drawCircle(x6, y6, r6);
    
    if (digitalRead(IN_4) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(180,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(180,150,6);  
    }

// Input 5
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("5", 195, 145); 
    myGLCD.setColor(0,0,0);   
    int x7=210; int y7=150; int r7=7;
    myGLCD.drawCircle(x7, y7, r7);
    
    if (digitalRead(IN_5) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(210,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255);  
      myGLCD.fillCircle(210,150,6);  
    }

// Input 6
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("6", 225, 145); 
    myGLCD.setColor(0,0,0);   
    int x8=240; int y8=150; int r8=7;
    myGLCD.drawCircle(x8, y8, r8);
    
    if (digitalRead(IN_6) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(240,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255);
      myGLCD.fillCircle(240,150,6);  
    }

// Input 7
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("7", 255, 145); 
    myGLCD.setColor(0,0,0);   
    int x9=270; int y9=150; int r9=7;
    myGLCD.drawCircle(x9, y9, r9);
    
    if (digitalRead(IN_7) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(270,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255);  
      myGLCD.fillCircle(270,150,6); 
    }

// Input 8
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("8", 285, 145); 
    myGLCD.setColor(0,0,0);   
    int x10=300; int y10=150; int r10=7;
    myGLCD.drawCircle(x10, y10, r10);
    
    if (digitalRead(IN_8) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(300,150,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(300,150,6); 
    }

// Output 1 - PWM1
    myGLCD.setColor(0, 0, 0);  // BLACK FONT             
    myGLCD.print("Output:", 5, 125); 
    myGLCD.print("1", 75, 125); 
    myGLCD.setColor(0,0,0);   
    int x11=90; int y11=130; int r11=7;
    myGLCD.drawCircle(x11, y11, r11);
    
    if (digitalRead(OUT_1) == 0){
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(90,130,6);  
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(90,130,6);  
    }

// Output 2 - PWM2
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("2", 105, 125); 
    myGLCD.setColor(0,0,0);   
    int x12=120; int y12=130; int r12=7;
    myGLCD.drawCircle(x12, y12, r12);
    
    if (digitalRead(OUT_2) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(120,130,6);
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(120,130,6);  
    }

  // Output 3 - PWM3
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("3", 135, 125); 
    myGLCD.setColor(0,0,0);   
    int x13=150; int y13=130; int r13=7;
    myGLCD.drawCircle(x13, y13, r13);
    
    if (digitalRead(OUT_3) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(150,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(150,130,6);  
    }

// Output 4 - PWM4
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("4", 165, 125); 
    myGLCD.setColor(0,0,0);   
    int x14=180; int y14=130; int r14=7;
    myGLCD.drawCircle(x14, y14, r14);
    
    if (digitalRead(OUT_4) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(180,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255);  
      myGLCD.fillCircle(180,130,6);  
    }

// Output 5
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("5", 195, 125); 
    myGLCD.setColor(0,0,0);   
    int x15=210; int y15=130; int r15=7;
    myGLCD.drawCircle(x15, y15, r15);
    
    if (digitalRead(OUT_5) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(210,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(210,130,6);  
    }

// Output 6
    myGLCD.setColor(0, 0, 0);             
    myGLCD.print("6", 225, 125); 
    myGLCD.setColor(0,0,0);   
    int x16=240; int y16=130; int r16=7;
    myGLCD.drawCircle(x16, y16, r16);
    
    if (digitalRead(OUT_6) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(240,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(240,130,6);  
    }

// Output 7
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("7", 255, 125); 
    myGLCD.setColor(0,0,0);   
    int x17=270; int y17=130; int r17=7;
    myGLCD.drawCircle(x17, y17, r17);
    
    if (digitalRead(OUT_7) == 0) { 
      myGLCD.setColor(0,255,0);      
      myGLCD.fillCircle(270,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255);  
      myGLCD.fillCircle(270,130,6);  
    }

// Output 8
    myGLCD.setColor(0, 0, 0);            
    myGLCD.print("8", 285, 125); 
    myGLCD.setColor(0,0,0);   
    int x18=300; int y18=130; int r18=7;
    myGLCD.drawCircle(x18, y18, r18);
    
    if (digitalRead(OUT_8) == 0) { 
      myGLCD.setColor(0,255,0);     
      myGLCD.fillCircle(300,130,6); 
    }
    else {
      myGLCD.setColor(255,255,255); 
      myGLCD.fillCircle(300,130,6);  
    }
}

// Read Buttons 
 void Read_Buttons(){
 if (digitalRead(BUTT_H) == 0) { 
    if   (b_BUTT_H == 0){b_BUTT_H = 1;}
    else {b_BUTT_H = 0;}
    digitalWrite(BEEP, LOW);
    delay (300);
    digitalWrite(BEEP, HIGH);
    
  }

 if (digitalRead(BUTT_L) == 0) { 
    if   (b_BUTT_L == 0){b_BUTT_L = 1;}
    else {b_BUTT_L = 0;}
    digitalWrite(BEEP, LOW);
    delay (300);
    digitalWrite(BEEP, HIGH);
  }
}


